//*****************************************************************************************
//   
//*****************************************************************************************
#if !ASM
void write_byte(void)
{	
    _WDR();					//   
    DDRC = 0;				//    , 
							//    ,  
    PORTC = 0xFF;			//     C
    PORTD = 0x50;			//       
    left_right |= RES_OFF;
    PORTG = left_right;		//   
    _NOP();
    _NOP();
    PORTD |= E;				//   /
    _NOP();
    _NOP();
    while (PINC & 0x80);	//     
    PORTD = 0x50;			//    /  
							//     
    _NOP();
    _NOP();
    DDRC = 0xFF;			//    , 
							//    ,  
    data_comm |= LIGHT_ON; 	//   
    PORTD = data_comm;		//    
    PORTC = byte;
    _NOP();
    _NOP();
    PORTD |= E; 			//   /
    _NOP();
    _NOP();
    PORTD = data_comm; 		//    /  
							//     
    _NOP();
    _NOP();
}
// ****************************************************************************************
void write_comm_L(void)
{
    left_right = E1;
    data_comm = 0;
    write_byte();
}
// ****************************************************************************************
void write_comm_R(void)
{
    left_right = E2;
    data_comm = 0;
    write_byte();
}
// ****************************************************************************************
void write_data_L(void)
{
    left_right = E1;
    data_comm = A0;
    write_byte();
}
// ****************************************************************************************
void write_data_R(void)
{
    left_right = E2;
    data_comm = A0;
    write_byte();
}
// ****************************************************************************************
//     

void write_LCD(unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
        if (inwert == 0)
            byte = simbol[col];
        if (inwert == 0xFF)
            byte = ~(simbol[col]);
        column ++;
	    write_byte();
  	}
}
// ****************************************************************************************
//         (    )

void write_LCD_1(unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
		byte = (simbol[col]);
        column_1 ++;
	    write_byte();
  	}
}
#endif
//*****************************************************************************************
void initial_LCD(void)
{
    _WDR();					//   
    PORTD =LIGHT_ON;	
    PORTG = RES_OFF;
    PORTG = RES_ON;
    _NOP();
    _NOP();
    PORTG = RES_OFF;
	_delay_us(4);
    byte = START_LINE;	
    write_comm_L();
    write_comm_R();
    byte = DISPLAY_ON;
    write_comm_L();
    write_comm_R();
    byte = SET_PAGE;	
    write_comm_L();
    write_comm_R();
    byte = SET_ADDRESS;	
    write_comm_L();
    write_comm_R();
}
//*****************************************************************************************
void black_screen(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_L();
        write_comm_R();
        byte = SET_ADDRESS;
        write_comm_R();
        write_comm_L();
        for(col = 0; col < 64; col++){
            byte = 0xFF;
            write_data_L();
            write_data_R();
        }
    }
}
//*****************************************************************************************
void clean_screen(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_R();
        write_comm_L();
        byte = SET_ADDRESS;
        write_comm_R();
        write_comm_L();
        for(col = 0; col < 64; col++){
            byte = 0x00;
            write_data_R();
            write_data_L();
        }
    }
    byte = SET_PAGE;
    write_comm_R();
    write_comm_L();
    byte = SET_ADDRESS;
    write_comm_R();
    write_comm_L();
}
//*****************************************************************************************
void picture(void)
{
    for(page_lcd =0; page_lcd < 8; page_lcd ++){
        byte = page_lcd | SET_PAGE;
        write_comm_L();
        write_comm_R();
        byte = SET_ADDRESS;
        write_comm_L();
        write_comm_R();
        for(col = 0; col < 64; col++){
            byte = Picture[page_lcd][col];
            write_data_L();
            byte = Picture[page_lcd][col + 64];
            write_data_R();
        }
    }
}
//*****************************************************************************************
void display_position(unsigned char string, unsigned char font_reticle_L,
				   unsigned char font_reticle_R)
{
	font_reticle_L *= 8;
	font_reticle_R *= 8;
	
	byte = START_LINE;	
    write_comm_L();
    write_comm_R();
    byte = string | SET_PAGE;
    write_comm_L();
    write_comm_R();
    byte = SET_ADDRESS;
    byte = font_reticle_R | SET_ADDRESS;
    write_comm_R();
    byte = font_reticle_L | SET_ADDRESS;
    write_comm_L();
    data_comm = A0;
}
//*****************************************************************************************
//*****************************************************************************************
//*****************************************************************************************
#if ASM
//        
void write_byte(unsigned char byte, unsigned char left_right, unsigned char data_comm)
//  AVR GCC
//byte  			r24,
//left_right   	r22,
//data_comm   	r20
{
asm(
	"wdr                            \n"
	"clr 	r16                     \n"
	"out	0x14, r16               \n"
	"ser 	r16	               	 	\n"
	"out	0x15, r16               \n"
	"ldi	r16, 0x50               \n"//  0101 0000
	"out	0x12, r16               \n"
	"ldi	r16, 0x4                \n"//  0000 0100
	"or	r16, r22               		\n"
	"sts	0x65, r16               \n"
	"nop			                \n"
	"nop			                \n"
	"ldi	r16, 0xD0               \n"//  1101 0000
	"out	0x12, r16               \n"
	"nop			                \n"
	"nop			                \n"
"wait_busy:                         \n"
	"sbic 0x13, 7                   \n"//  
	"rjmp 	wait_busy               \n"
	"ldi	r16, 0x50               \n"//  0101 0000
	"out	0x12, r16               \n"
	"nop			                \n"
	"nop			                \n"
	"ser 	r16     	        	\n"
	"out	0x14, r16               \n"
	"ldi	r16, 0x10               \n"//  0001 0000
	"or	r16, r20                	\n"
	"out	0x12, r16               \n"
	"mov    r16, r24                \n"
	"out	0x15, r16               \n"
	"nop			                \n"
	"nop			                \n"
	"ldi	r16, 0x90               \n"//  1001 0000
	"or	r16, r20                	\n"
	"out	0x12, r16               \n"
	"nop			                \n"
	"nop			                \n"
	"ldi	r16, 0x10               \n"//  0001 0000
	"or	r16, r20                	\n"
	"out	0x12, r16               \n"
	"nop			                \n"
	"nop			                \n");
//	"ret                            \n");	//   ret  , ..
											//  AVR GCC   
											//    
}
// ****************************************************************************************
void write_comm_L(void)
{
    left_right = E1;
    data_comm = 0;
	write_byte(byte, left_right, data_comm);
}
// ****************************************************************************************
void write_data_L(void)
{
    left_right = E1;
    data_comm = A0;
	write_byte(byte, left_right, data_comm);
}
// ****************************************************************************************
void write_comm_R(void)
{
    left_right = E2;
    data_comm = 0;
	write_byte(byte, left_right, data_comm);
}
// ****************************************************************************************
void write_data_R(void)
{
    left_right = E2;
    data_comm = A0;
	write_byte(byte, left_right, data_comm);
}
// ****************************************************************************************
//     

void write_LCD(unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
        if (inwert == 0)
            byte = simbol[col];
        if (inwert == 0xFF)
            byte = ~(simbol[col]);
        column ++;
		write_byte(byte, left_right, data_comm);
  	}
}
// ****************************************************************************************
//         (    )

void write_LCD_1(unsigned char simbol[])
{
	static unsigned char col;
	for (col = 0; col < 8; col ++){
		byte = (simbol[col]);
        column_1 ++;
		write_byte(byte, left_right, data_comm);
  	}
}
#endif
//*****************************************************************************************
