//*****************************************************************************************
//      DS1307
//*****************************************************************************************
//    -  

void tetrada_L(unsigned char code)
{

    _WDR();
    switch(code)
    {
        case 0x0: write_LCD(n_0); break;
        case 0x1: write_LCD(n_1); break;
        case 0x2: write_LCD(n_2); break;
        case 0x3: write_LCD(n_3); break;
        case 0x4: write_LCD(n_4); break;
        case 0x5: write_LCD(n_5); break;
        case 0x6: write_LCD(n_6); break;
        case 0x7: write_LCD(n_7); break;
        case 0x8: write_LCD(n_8); break;
        case 0x9: write_LCD(n_9); break;
    }
}
//*****************************************************************************************
//    -  

void tetrada_H(unsigned char code)
{
_WDR();
    switch(code)
    {
        case 0x00: write_LCD(n_0); break;
        case 0x10: write_LCD(n_1); break;
        case 0x20: write_LCD(n_2); break;
        case 0x30: write_LCD(n_3); break;
        case 0x40: write_LCD(n_4); break;
        case 0x50: write_LCD(n_5); break;
        case 0x60: write_LCD(n_6); break;
        case 0x70: write_LCD(n_7); break;
        case 0x80: write_LCD(n_8); break;
        case 0x90: write_LCD(n_9); break;
    }
}
//*****************************************************************************************
//         

void indication_time(unsigned char hour, unsigned char min, unsigned char second)
{
    _WDR();

    left_right = E2;
	inwert = 0;

    byte = (hour & 0xf0);
    tetrada_H(byte);
    byte = (hour & 0x0f);
    tetrada_L(byte);

	//   
    byte = 0x00;
    write_data_R();
    byte = 0x42;                //  0100 0010
    write_data_R();
    byte = 0x00;
    write_data_R();
    byte = 0x00;
    write_data_R();

    byte = (min & 0xf0);
    tetrada_H(byte);
    byte = (min & 0x0f);
    tetrada_L(byte);

	//   
    byte = 0x00;
    write_data_R();
    byte = 0x42;                //  0100 0010
    write_data_R();
    byte = 0x00;
    write_data_R();
    byte = 0x00;
    write_data_R();

    byte = (second & 0xf0);
    tetrada_H(byte);
    byte = (second & 0x0f);
    tetrada_L(byte);
}
//*****************************************************************************************
//         

void indication_date(unsigned char day, unsigned char month, unsigned char year)
{
    _WDR();

	inwert = 0;

	byte = (day & 0xf0);
    tetrada_H(byte);
    byte = (day & 0x0f);
    tetrada_L(byte);

	//   
    byte = 0x00;
    write_data_L();
    byte = 0x42;                //  0100 0010
    write_data_L();
    byte = 0x00;
    write_data_L();
    byte = 0x00;
    write_data_L();

    byte = (month & 0xf0);
    tetrada_H(byte);
    byte = (month & 0x0f);
    tetrada_L(byte);

	//   
    byte = 0x00;
    write_data_L();
    byte = 0x42;                //  0100 0010
    write_data_L();
    byte = 0x00;
    write_data_L();
    byte = 0x00;
    write_data_L();

    byte = (year & 0xf0);
    tetrada_H(byte);
    byte = (year & 0x0f);
    tetrada_L(byte);
}
//*****************************************************************************************
//   

void time_save(void)
{
    hour_save = hour;
    min_save = min;
    second_save = second;
}
//*****************************************************************************************
//   

void date_save(void)
{
    day_save = day;
    month_save = month;
    year_save = year;
	week_save = week;
}
//*****************************************************************************************
//  

void date_change(unsigned char change)
{
    static unsigned char change_save, key, max;

    _WDR();

	//        
    switch (cursor_invert)
    {
    case 0: max = '3'; break;	//  
    case 1: max = '9'; break;	//  
    case 2: max = '1'; break;	//  
    case 3: max = '9'; break;	//  
    case 4: max = '9'; break;	//  
    case 5: max = '9'; break;	//  
    case 6: max = '7'; break;	//  
    }

	//    - 
	// ( ,  ,  )
	if ((cursor_invert == 0) || (cursor_invert == 2) || (cursor_invert == 4))
        if ((key_simb >= '0') && (key_simb <= max)){
            switch (key_simb)
            {
            case '0': key = 0x00; break;
            case '1': key = 0x10; break;
            case '2': key = 0x20; break;
            case '3': key = 0x30; break;
            case '4': key = 0x40; break;
            case '5': key = 0x50; break;
            case '6': key = 0x60; break;
            case '7': key = 0x70; break;
            case '8': key = 0x80; break;
            case '9': key = 0x90; break;
            }
            _CLI();
            change_save = change;
            change_save &= 0x0F;
            change_save |= key;
			//       
            switch (cursor_invert)
            {
            case 0:
				day_save = change_save;
				if (day_save > 0x31)
                    day_save = 0x31;
                if (day_save == 0x00)
                    day_save = 0x01;
				break;
            case 2:
				month_save = change_save;
				if (month_save > 0x12)
                    month_save = 0x12;
                if (month_save == 0x00)
                    month_save = 0x01;
				break;
            case 4: year_save = change_save; break;
            }
            cursor_invert ++;
            if (cursor_invert > 6)
                cursor_invert = 0;

            menu_date();	// " "
            _SEI();
            delay_mc(KEYBOARD_DELAY);
        }

	//    - 
	// ( ,  ,  )
	if ((cursor_invert == 1) || (cursor_invert == 3) || (cursor_invert == 5))
        if ((key_simb >= '0') && (key_simb <= max)){
            switch (key_simb)
            {
            case '0': key = 0x00; break;
            case '1': key = 0x01; break;
            case '2': key = 0x02; break;
            case '3': key = 0x03; break;
            case '4': key = 0x04; break;
            case '5': key = 0x05; break;
            case '6': key = 0x06; break;
            case '7': key = 0x07; break;
            case '8': key = 0x08; break;
            case '9': key = 0x09; break;
            }

            _CLI();
			//       
            switch (cursor_invert)
            {
            case 1:
                day_save &= 0xF0;
                day_save |= key;
                if (day_save > 0x31)
                    day_save = 0x31;
                if (day_save == 0x00)
                    day_save = 0x01;
                ; break;
            case 3:
                month_save &= 0xF0;
                month_save |= key;
                if (month_save > 0x12)
                    month_save = 0x12;
                if (month_save == 0x00)
                    month_save = 0x01;
                ; break;
            case 5:
                year_save &= 0xF0;
                year_save |= key;
                ; break;
            }
            cursor_invert ++;
            if (cursor_invert > 6)
                cursor_invert = 0;

            menu_date();	// " "
            _SEI();
            delay_mc(KEYBOARD_DELAY);
        }

	//      
	if (cursor_invert == 6)
        if ((key_simb >= '1') && (key_simb <= max)){
            switch (key_simb)
            {
            case '1': key = 0x01; break;
            case '2': key = 0x02; break;
            case '3': key = 0x03; break;
            case '4': key = 0x04; break;
            case '5': key = 0x05; break;
            case '6': key = 0x06; break;
            case '7': key = 0x07; break;
            }

            _CLI();
			week_save = key;

            menu_date();	// " "
            _SEI();
            delay_mc(KEYBOARD_DELAY);
        }
}
//*****************************************************************************************
//  

void time_change(unsigned char change)
{
    static unsigned char change_save, key, max;

    _WDR();

	//        
    switch (cursor_invert)
    {
    case 0: max = '2'; break;	//  
    case 1: max = '9'; break;	//  
    case 2: max = '5'; break;	//  
    case 3: max = '9'; break;	//  
    case 4: max = '5'; break;	//  
    case 5: max = '9'; break;	//  
    }

	//    - 
	// ( ,  ,  )
	if ((cursor_invert == 0) || (cursor_invert == 2) || (cursor_invert == 4))
        if ((key_simb >= '0') && (key_simb <= max)){
            switch (key_simb)
            {
            case '0': key = 0x00; break;
            case '1': key = 0x10; break;
            case '2': key = 0x20; break;
            case '3': key = 0x30; break;
            case '4': key = 0x40; break;
            case '5': key = 0x50; break;
            case '6': key = 0x60; break;
            case '7': key = 0x70; break;
            case '8': key = 0x80; break;
            case '9': key = 0x90; break;
            }
            _CLI();
            change_save = change;
            change_save &= 0x0F;
            change_save |= key;
			//       
            switch (cursor_invert)
            {
            case 0:
				hour_save = change_save;
				if (hour_save > 0x23)
                    hour_save = 0x23;
				break;
            case 2:
				min_save = change_save;
				if (min_save > 0x59)
                    min_save = 0x59;
				break;
            case 4: second_save = change_save; break;
            }
            cursor_invert ++;
            if (cursor_invert > 5)
                cursor_invert = 0;

            menu_time();	// " "
            _SEI();
            delay_mc(KEYBOARD_DELAY);
        }

	//    - 
	// ( ,  ,  )
	if ((cursor_invert == 1) || (cursor_invert == 3) || (cursor_invert == 5))
        if ((key_simb >= '0') && (key_simb <= max)){
            switch (key_simb)
            {
            case '0': key = 0x00; break;
            case '1': key = 0x01; break;
            case '2': key = 0x02; break;
            case '3': key = 0x03; break;
            case '4': key = 0x04; break;
            case '5': key = 0x05; break;
            case '6': key = 0x06; break;
            case '7': key = 0x07; break;
            case '8': key = 0x08; break;
            case '9': key = 0x09; break;
            }

            _CLI();
			//       
            switch (cursor_invert)
            {
            case 1:
                hour_save &= 0xF0;
                hour_save |= key;
                if (hour_save > 0x23)
                    hour_save = 0x23;
                ; break;
            case 3:
                min_save &= 0xF0;
                min_save |= key;
                if (min_save > 0x59)
                    min_save = 0x59;
                ; break;
            case 5:
                second_save &= 0xF0;
                second_save |= key;
                ; break;
            }
            cursor_invert ++;
            if (cursor_invert > 5)
                cursor_invert = 0;

            menu_time();	// " "
            _SEI();
            delay_mc(KEYBOARD_DELAY);
        }
}
//*****************************************************************************************
//      DS1307   TWI
//*****************************************************************************************
//    7    00H
//     "1",   DS1307 
//    :
//  7    00H   "0",
//     ,  
// , , ,  , , ,
//    ,
//     07H   0x10,
//       SWQ/OUT 
//  1 ,      INT3
// ATMEGA128       
// ,     DS1307  
//     12864
void clock(void)
{
//   START

    if (start_twi() == ERROR)
        return;

//      

    if (sla_w(WRITE_ADDR) == ERROR)
        return;

//    ,   
//     (   )

    if (write_byte_twi(0) == ERROR)
        return;

//   REPEATED START

    if (rep_start() == ERROR)
        return;

//      

    if (sla_r(READ_ADDR) == ERROR)
        return;

//     00H

    if (read_byte_twi() == ERROR)
      return;

    if (!(TWDR & 0x80)){
		if (last_byte_twi() == ERROR)
			return;
		stop_twi();
        return;
	}
	
    if (last_byte_twi() == ERROR)
        return;

//   REPEATED START

    if (rep_start() == ERROR)
        return;
//-----------------------------------------------------------------------------------------	
//    

//      

    if (sla_w(WRITE_ADDR) == ERROR)
        return;

//    ,   
//     (   )

    if (write_byte_twi(0) == ERROR)
        return;

//     

//  -   00H
    if (write_byte_twi(0x47) == ERROR)
        return;

//  -   01H
    if (write_byte_twi(0x30) == ERROR)
        return;

//  -   02H
    if (write_byte_twi(0x12) == ERROR)
        return;

//   -   03H
    if (write_byte_twi(0x07) == ERROR)
        return;

//  -   04H
    if (write_byte_twi(0x01) == ERROR)
        return;

//  -   05H
    if (write_byte_twi(0x01) == ERROR)
        return;

//  -   06H
    if (write_byte_twi(0x07) == ERROR)
        return;

//   SWQ/OUT  1  -   07H
    if (write_byte_twi(0x10) == ERROR)
        return;

	stop_twi();
}
//*****************************************************************************************
//      TWI       
//   DS1307       12864
//      -  

void read_data_clock(void)
{
//   START

    if (start_twi() == ERROR)
        return;
	
//      

    if (sla_w(WRITE_ADDR) == ERROR)
        return;

//    ,   
//     (   )

//    byte = 0;
    if (write_byte_twi(0) == ERROR)
        return;

//   REPEATED START

    if (rep_start() == ERROR)
        return;

//      

    if (sla_r(READ_ADDR) == ERROR)
        return;

//     00H - 06H

    if (read_byte_twi() == ERROR)
        return;

    second = TWDR & 0x7F;       //  0111 1111

    if (read_byte_twi() == ERROR)
        return;

    min = TWDR & 0x7F;          //  0111 1111

    if (read_byte_twi() == ERROR)
        return;

    hour = TWDR & 0x3F;         //  0011 1111

    if (read_byte_twi() == ERROR)
        return;

    week = TWDR & 0x7;          //  0000 0111


    if (read_byte_twi() == ERROR)
        return;

    day = TWDR & 0x3F;          //  0011 1111

    if (read_byte_twi() == ERROR)
        return;

    month = TWDR & 0x3F;        //  0011 1111

    if (read_byte_twi() == ERROR)
        return;

    year = TWDR;
	
    if (last_byte_twi() == ERROR)
        return;
	
	stop_twi();
	
	//    -  
	if ((season != SUMMER) && (week == 0x07) && (month == 0x03)
		&& (hour >= 0x02) && (day > 0x24)){
		season = SUMMER;
		time_save();
		hour_save += 1;
		write_time_clock();
	}

	if ((season != WINTER) && (week == 0x07) &&	(month == 0x10)
		&& (hour >= 0x03) && (day > 0x24)){
		season = WINTER;
		time_save();
		hour_save -= 1;
		write_time_clock();
	}


	display_position(7, 0, 1);
	indication_time(hour, min, second);
	display_position(7, 0, 0);
	indication_date(day, month, year);
}
//*****************************************************************************************
//     TWI     
//        DS1307

void write_date_clock(void)
{
	time_save();
	
	write_clock();
}
//*****************************************************************************************
//     TWI    
//         DS1307

void write_time_clock(void)
{
	date_save();
	
	write_clock();
}
//*****************************************************************************************
//     TWI      DS1307

void write_clock(void)
{
//   START

    if (start_twi() == ERROR)
        return;

//      

    if (sla_w(WRITE_ADDR) == ERROR)
        return;

//    ,   
//     (   )

    if (write_byte_twi(0) == ERROR)
        return;

//     

//  -   00H
    if (write_byte_twi(second_save) == ERROR)
        return;

//  -   01H
    if (write_byte_twi(min_save) == ERROR)
        return;

//  -   02H
    if (write_byte_twi(hour_save) == ERROR)
        return;

//   -   03H
    if (write_byte_twi(week_save) == ERROR)
        return;

//  -   04H
    if (write_byte_twi(day_save) == ERROR)
        return;

//  -   05H
    if (write_byte_twi(month_save) == ERROR)
        return;

//  -   06H
    if (write_byte_twi(year_save) == ERROR)
        return;
	
	stop_twi();
}
//*****************************************************************************************
